SuperStrict
Framework brl.max2d
Import brl.system
Import brl.stream
Import brl.standardio
Import brl.retro
Import brl.random
Import brl.pngloader
Import brl.pixmap
Import brl.linkedlist
Import brl.jpgloader
Import brl.blitz
Import brl.basic
Import brl.polledinput
Import brl.math
Import brl.glmax2d

SeedRnd MilliSecs()

Global screenx:Float = 800
Global screeny:Float = 600
Global split20x:Float = screenx / 5.0
Global split20y:Float = screeny / 5.0
Global pointx:Float = screenx / 2.0
Global pointy:Float = screeny / 2.0

SetGraphicsDriver GLMax2DDriver()

AppTitle = "meep meep"
Global fenster:TGraphics = Graphics(screenx, screeny,,, GRAPHICS_BACKBUFFER | GRAPHICS_ALPHABUFFER | GRAPHICS_ACCUMBUFFER)

SetBlend(ALPHABLEND)

Global back1:TImage = LoadImage("1.png")
Global back2:TImage = LoadImage("2.png")
Global back3:TImage = LoadImage("3.png")
Global wpn:TImage = LoadImage("ge.png")
Global scheibe:TImage = LoadImage("zs.png")
Global clouds:TImage = LoadImage("clouds.png")
Global cloudmovex:Float
Global glow:TImage = LoadImage("glow.png")
glow.handle_x = 10
glow.handle_y = 230

Global pew:TImage = LoadImage("pew.png")
pew.handle_x = 100
pew.handle_y = 100

Global spawntimer:Int
Global score:Int
 
Type Ttarget
	Global list:TList = CreateList()
	Field x:Float, y:Float, move:Byte, l:Byte, yb:Float, rnd1:Float = Rnd(5, 20), rnd2:Float = Rnd(0, 360), rnd3:Float = Rnd(0, 20)
	
	Function Create()
		Local nt:Ttarget = New Ttarget
		list.AddLast(nt)
		Select Rand(0, 2)
			Case 0
				nt.y = 220
				nt.l = 0
			Case 1
				nt.y = 300
				nt.l = 1
			Case 2
				nt.y = 380
				nt.l = 2
		End Select
		If Rand(0, 1) Then
			nt.move = True
			nt.x = 800
		End If
	End Function
	Function draw(l:Byte)
		For Local wt:Ttarget = EachIn list
			If wt.l = l Then
				If wt.move Then
					wt.x:-calc_move(10 + wt.rnd3)
					If wt.x < - 100 Then list.Remove(wt)
				Else
					wt.x:+calc_move(10 + wt.rnd3)
					If wt.x > 800 Then list.Remove(wt)
				End If
				wt.yb = ((Sin((MilliSecs() + wt.rnd2) / wt.rnd1) - 1) * 30)
				DrawImage(scheibe, wt.x, wt.y - wt.yb)
			EndIf
		Next
	End Function
	
	Function hit(x:Float, y:Float)
		For Local wt:Ttarget = EachIn list
			Local entf:Float = Sqr((wt.x + 50 - x) ^ 2 + ((wt.y - wt.yb) + 50 - y) ^ 2)
			If entf < 50 Then
				list.Remove(wt)
				score:+20 + wt.rnd3
			End If
		Next
	End Function
EndType


Global msc:Int
Global lasttime:Int = MilliSecs()
Global time:Int = MilliSecs()
HideMouse()
While Not AppTerminate()
	lasttime = time
	time = MilliSecs()
	msc = time - lasttime
	If msc > 500 Then msc = 500
	
	Cls
	SetColor(50, 50, 50)
	DrawRect(0, 0, screenx, screeny)
	SetColor(255, 255, 255)
	
	spawntimer:-msc
	If spawntimer < 0 Then Ttarget.Create() ;spawntimer = Rnd(300, 1500)
	
	Ttarget.draw(0)
	DrawImage(back3, 0, 0)
	Ttarget.draw(1)
	DrawImage(back2, 0, 0)
	Ttarget.draw(2)
	DrawImage(back1, 0, 0)
	Local mx:Float = MouseX(), my:Float = MouseY()
	DrawImage(wpn, mx - 400, my - 300)
	SetColor(0, 0, 0)
	DrawRect(mx - 800, my + 300, 1600, 600)
	SetColor(255, 255, 255)
	
	Local ppew:Byte
	If MouseHit(1) Then
		score:-10
		Ttarget.hit(mx, my)
		ppew = True
	End If
	
	glClear(GL_ACCUM_BUFFER_BIT)
	glAccum(GL_LOAD, 1)
	
	Cls
	'SetColor(150, 150, 150)
	DrawRect(0, 0, screenx, screeny)
	SetColor(0, 0, 0)
	SetScale(3, 3)
	SetRotation(45 + (Sin(MilliSecs() / 20.0) * 35.0))
	DrawImage(glow, 0, 0)
	SetRotation(135 + (Sin(MilliSecs() / 15.0) * 35.0))
	DrawImage(glow, 800, 0)
	SetRotation(0)
	SetScale(5, 5)
	If ppew Then
		SetColor(0, 0, 255)
		DrawImage(pew, mx, my)
	End If
	SetScale(2, 2)
	SetColor(255, 255, 255)

	SetAlpha(0.3)
	For Local y:Int = 0 To 3
		For Local x:Int = 0 To 3
			DrawImage(clouds, (x * 1000) - cloudmovex, y * 1000)
		Next
	Next
	SetAlpha(1)
	SetScale(1, 1)
	cloudmovex:+calc_move(2)
	If cloudmovex > 1000 Then cloudmovex:-1000
	
	glAccum(GL_ACCUM, -1.0)
	
	
	Cls
	glAccum(GL_RETURN, 1)
	
	DrawText(score, 10, 10)
	Flip(1)
Wend

End

Function reset_draw()
	SetRotation(0)
	SetColor(255, 255, 255)
	SetHandle(0.0, 0.0)
	SetAlpha(1.0)
	SetScale(1.0, 1.0)
	SetOrigin(0.0, 0.0)
End Function

Function calc_move:Float(speed:Float)
	If speed <> 0 Then Return ((speed * Float(msc) / 100.0)) Else Return 0
End Function

Function calc_keymove:Float(entferung:Float, timing:Float)
	If entferung <> 0 And timing > 0 Then Return ((entferung / timing) * Float(msc)) Else Return 0
End Function

Function ismouseover:Byte(x:Int, y:Int, l:Int, w:Int)
	If x < MouseX() And x + l > MouseX() And y < MouseY() And y + w > MouseY() Then Return 1 Else Return 0
End Function





