﻿SuperStrict
rem
	Beitrag von Xeres zum BCC #47 - ohne Worte
	http://www.blitzforum.de/forum/viewtopic.php?t=36487
	12.288 Bytes
	2MiB Ressourcen
	Abgabe: 12.Februar (Freitag) um 23:59. 
	
	BlockSchock
	"KD Game"-clone - PuzzleSpiel
	
endrem

AppTitle = "BlockSchock"
 
Global gfx_w:Int = 896, gfx_h:Int = 768
Graphics(gfx_w, gfx_h)
AutoMidHandle(True)
SeedRnd(MilliSecs())
Local FrameTimer:TTimer = TTimer.Create(60)

Global Steuerung:TImage = LoadImage("Data\gfx\Steuerung.png")
Global Exitimg:TImage = LoadAnimImage("Data\gfx\Exit.png", 64, 64, 0, 2)
Global Trashimg:TImage = LoadAnimImage("Data\gfx\Trash.png", 64, 64, 0, 2)
Global XOKimg:TImage = LoadAnimImage("Data\gfx\XOk.png", 64, 64, 0, 8)
Global TileSet:TImage = LoadAnimImage("Data\gfx\TileSet.png", 64, 64, 0, 16)
Global Colors:TImage = LoadAnimImage("Data\gfx\colors6x64.png", 64, 64, 0, 6)
Global SpezialIMG:TImage = LoadImage("Data\gfx\Spezial.png")
Global ScheinIMG:TImage = LoadImage("Data\gfx\Schein.png")
Global Soundimg:TImage = LoadAnimImage("Data\gfx\snd.png", 64, 64, 0, 8)

SetImageFont(LoadImageFont(getenv_("windir") + "\fonts\" + "Arial.ttf", 18))

Global ButtonHitSnd:TSound = LoadSound("Data\sfx\ButtonHit.ogg")
Global ButtonPitSnd:TSound = LoadSound("Data\sfx\ButtonPit.ogg")
Global EreaseSnd:TSound = LoadSound("Data\sfx\erease.ogg")
Global TrashSnd:TSound = LoadSound("Data\sfx\trash.ogg")
Global MhMhSnd:TSound = LoadSound("Data\sfx\mhmh.ogg")
Global SetzSnd:TSound = LoadSound("Data\sfx\setz.ogg")
Global Volume:Int = 1

Global Mainboard:TGameboard = TGameboard.Create(gfx_w / 2, gfx_h / 2, 8, 13)
Global IntroBoardColor:TGameboard = TGameboard.Create(gfx_w / 2, gfx_h * 0.40, 1, 8)
Global IntroBoardObj:TGameboard = TGameboard.Create(gfx_w / 2, gfx_h * 0.60, 1, 8)

LoadOptions()
THighscore.Load()
OnEnd(THighscore.Save)
OnEnd(SaveOptions)

SetBlend(AlphaBlend)
SetClsColor(255, 255, 255)

Global mx:Int, my:Int, mh1:Int, mh2:Int, ms:Int
Global mousehover:Int, mousehoverOld:Int

Global Points:Int, Level:Int, LevelMAX:Int = 15, LevelTile:Int, LevelTime:Int

Global CR:Int = 128, CG:Int = 255, CB:Int = 128, CC:Int = 0

Const GS_Intro:Int = 0, GS_Menu:Int = 1, GS_Spiel:Int = 2, GS_High:Int = 3, GS_Input:Int = 4
Global GameState:Int = GS_Intro

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	mousehoverOld = mousehover
	mousehover = False
	
	If ButtonImg(Exitimg, 32, 32, 0, 1) Then End
	If ButtonImg(Soundimg, gfx_w - 32, 32, Volume, (Volume + 4) Mod 8, ButtonHitSnd) Then Volume = (Volume + 1) Mod 4
	
	Select GameState
		Case GS_Intro; Intro()
		Case GS_Menu; Menu()
		Case GS_Spiel; Spiel()
		Case GS_High; Highscore()
		Case GS_Input; HighscoreInput()
	End Select
	
	rem
	SetColor(0,0,0)
	DrawText(1.0 - (Volume / 3.0), 10, 10)
	SetColor(255, 255, 255)
	endrem
	
	Flip(0)
	Frametimer.Wait()
Until KeyHit(KEY_ESCAPE) Or AppTerminate()
End

Function Intro()
	Global Itimer:Int = ms + 2000, IArt:Int, INr:Int, Icol:Int = Rand(0, 5), IObj:Int = Rand(0, 15)
	
	DrawImage(Steuerung, gfx_w / 2, gfx_h *.20)
	If ButtonImg(XOKimg, gfx_w / 2, gfx_h - 48, 2, 3, ButtonHitSnd) Then
		GameState = GS_Menu
		IntroBoardColor.Flush()
		IntroBoardObj.Flush()
		TTile.Flush
		Itimer = 0; IArt = 0; INr = 0
		Return
	EndIf

	If TTile.ActiveTile = Null Then
		If IArt = 0 Then
			If INr < 8 Then TTile.Create(Rand(0, 15), Icol, gfx_w / 2, 64)
		Else
			If INr < 8 Then TTile.Create(IObj, Rand(0, 5), gfx_w / 2, 64)
		End If
		INr:+1
		If INr > 8 Then IArt:~1 ; INr = 0 ; Icol = Rand(0, 5) ; IObj = Rand(0, 15)
	End If
	If Itimer < ms Then
		Itimer = ms + 1500

		Local tx:Int = mx, ty:Int = my, th1:Int = mh1, th2:Int = mh2
		mh1 = 1
		mh2 = 0
		mx = 222 + (INr - 1) * 64
		If IArt = 0 Then
			my = gfx_h * 0.40
			IntroBoardColor.Mouse(True)
		Else
			my = gfx_h * 0.60
			IntroBoardObj.Mouse(True)
		End If
		mx = tx;my = ty;mh1 = th1;mh2 = th2
	EndIf

	'SetColor(0, 0, 0)
	'DrawText((Itimer - ms) + "; " + IArt + "; " + (INr - 1), 10, 10)
	'DrawText(mx + "," + my, 10, 10)
	'SetColor($FF, $FF, $FF)
	
	IntroBoardColor.Draw()
	IntroBoardObj.Draw()
	IntroBoardColor.Check()
	IntroBoardObj.Check()
	TTile.UpdateAll()
End Function

Function Menu()
	If ButtonImg(XOKimg, gfx_w / 2, gfx_h *.25, 2, 3, ButtonHitSnd) Then
		GameState = GS_Spiel
		Points = 0
		Level = 1
		'* 20 Minuten per Spiel:
		LevelTime = (ms / 1000) + 60 * 20
	EndIf
	If ButtonImg(XOKimg, gfx_w / 2, gfx_h *.45, 4, 5, ButtonHitSnd) Then GameState = GS_Intro
	If ButtonImg(XOKimg, gfx_w / 2, gfx_h *.65, 6, 7, ButtonHitSnd) Then GameState = GS_High
	'If ButtonImg(XOKimg, gfx_w / 2, gfx_h *.85, 0, 1, ButtonHitSnd) Then End
End Function

Function Spiel()
	rem
	If ButtonImg(Exitimg, 32, 32, 0, 1) Then
		GameState = GS_Menu
		Mainboard.Flush()
		TTile.Flush
		Return
	EndIf
	endrem
	SetColor(0, 0, 0)
	DrawTextMid(SecsToTime(LevelTime - (ms / 1000)), gfx_w *.25, 64) ; DrawTextMid(Points, gfx_w *.75, 64)
	SetColor(255, 255, 255)
	
	If TTile.ActiveTile = Null Then TTile.Create(Rand(0, 16), Rand(0, 5), gfx_w / 2, 64)
	If ButtonImg(Trashimg, gfx_w / 2, gfx_h - 48, 0, 1) Or mh2 Then PlayMySound(TrashSnd) ; TTile.DiscardActiveTile()
	If LevelTime - (ms / 1000) <= 0 Or ButtonImg(XOKimg, 96, 32, 0, 1) Then
		Mainboard.Flush()
		TTile.Flush()
		LevelTile = 0
		GameState = GS_Input
		Return
	End If
	If LevelTile = 0 Then
		Points:+((Level - 1) ^ 2) * 100
		Mainboard.Flush()
		Mainboard.LoadLevel(Level Mod (LevelMAX - 1))
		Level:+1
	EndIf
	Mainboard.Update()
	TTile.UpdateAll()
End Function

Function Highscore()
	'* Die 5 besten Einträge anzeigen.
	SetColor(0, 0, 0)
	For Local i:Int = 0 Until 5
		Local H:THighScore = THighScore(THighScore.list.ValueAtIndex(i))
		DrawTextMid(i + 1 + ".", gfx_w * 0.25, gfx_h *.25 + i * 72)
		SetColor(255, 255, 255) ;THighscore.DrawHigh(H.name, gfx_w *.5, gfx_h *.25 + i * 72) ;SetColor(0, 0, 0)
		DrawTextMid(H.Points, gfx_w * 0.75, gfx_h *.25 + i * 72)
	Next
	SetColor(255, 255, 255)
	
	If ButtonImg(XOKimg, gfx_w / 2, gfx_h - 48, 2, 3, ButtonHitSnd) Then GameState = GS_Menu

End Function

Function HighscoreInput()
	Global pn:String

	SetAlpha(Abs(Sin((ms Mod 3600) / 10.0)))
	DrawImage(ScheinIMG, gfx_w *.5, gfx_h *.12)
	SetAlpha(1)
	DrawImage(XOKimg, gfx_w *.5, gfx_h *.12, 7)
	SetColor(0, 0, 0)
	DrawTextMid(Points, gfx_w *.5, gfx_h *.22)
	SetColor(255, 255, 255)
	
	THighscore.DrawHigh(pn, gfx_w / 2, gfx_h *.3)
	
	Local i:Int = 0
	For Local y:Int = 0 Until 4
		For Local x:Int = 0 Until 4
			If pn.Length < 5 Then
				If ButtonImg(TileSet, gfx_w / 2 - 108 + x * 72, gfx_h *.45 + y * 72, i, -1) Then pn:+Chr(65 + i)
			Else
				SetColor(64, 64, 64)
				DrawImage(TileSet, gfx_w / 2 - 108 + x * 72, gfx_h *.45 + y * 72, i)
			EndIf
			i:+1
		Next
	Next
	
	SetColor(255, 255, 255)
	If ButtonImg(XOKimg, gfx_w *.80, gfx_h *.59, 0, 1) Then pn = Left(pn, pn.Length - 1)
	
	If pn.Length > 0 Then
		If ButtonImg(XOKimg, gfx_w / 2, gfx_h - 48, 2, 3, ButtonHitSnd) Then
			THighscore.Add(pn, Points)
			THighscore.list.Sort()
			pn = ""
			GameState = GS_High
		EndIf
	Else
		SetColor(64, 64, 64)
		DrawImage(XOKimg, gfx_w / 2, gfx_h - 48, 2)
		SetColor(255, 255, 255)
	EndIf
End Function

Type TTile
	Field objFrame:Int, colFrame:Int
	Field X:Float, Y:Float, XZ:Float, YZ:Float
	Field lifetime:Int, lvlp:Int
	Global ActiveTile:TTile
	Global AllTiles:TList = New TList
	
	Method Move()
		If Self.XZ = -1 Then Return
		Local vx:Float = Self.XZ - Self.X
		Local vy:Float = Self.YZ - Self.Y
		Local vz:Float = Sqr(vx * vx + vy * vy)
		vx = (vx / vz) * 16
		vy = (vy / vz) * 16
		If vz < 8 Then
			Self.X = Self.XZ
			Self.Y = Self.YZ
			Self.XZ = -1
		Else
			Self.X:+vx
			Self.Y:+vy
		EndIf
	End Method
	
	Method Draw()
		If Self.lvlp Then
			SetAlpha(Abs(Sin((ms Mod 3600) / 10.0)))
			DrawImage(ScheinIMG, Self.X, Self.Y)
			SetAlpha(1)
		EndIf
		If Self.objFrame = 16 Then
			SetColor(Limit(CR, 0, 255), Limit(CG, 0, 255), Limit(CB, 0, 255))
			DrawImage(SpezialIMG, Self.X, Self.Y)
			'SetColor(0, 0, 0) ; DrawText(CR + ", " + CG + ", " + CB, Self.X, Self.Y + 48)
		ElseIf Self.objFrame >= 0 Then
			DrawImage(TileSet, Self.X, Self.Y, Self.objFrame)
			DrawImage(Colors, Self.X, Self.Y, Self.colFrame)
		Else
			SetColor(Rand(255), Rand(128, 255), Rand(255))
			SetAlpha((Self.lifetime - ms) / 2000.0)
			DrawImage(SpezialIMG, Self.X, Self.Y)
		EndIf
		SetAlpha(1)
		SetColor(255, 255, 255)
	End Method
	
	Method Erease()
		Self.objFrame = -1
		Self.lifetime = ms + 2000
		If Self.lvlp Then LevelTile:-1; Self.lvlp = 0
		Points:+50
	End Method
	
	Method Del()
		If Self.XZ = -1 Then TTile.AllTiles.Remove(Self)
	End Method
	
	Function DiscardActiveTile()
		If TTile.ActiveTile.objFrame = 16 Then
			Points:+100
		Else
			Points:-20
		EndIf
		TTile.AllTiles.Remove(TTile.ActiveTile)
		TTile.ActiveTile = Null
	End Function
		
	Function SetDestActiveTile:TTile(x:Float, y:Float)
		Local tmp:TTile = ActiveTile
		ActiveTile.XZ = x
		ActiveTile.YZ = y
		ActiveTile = Null
		Return tmp
	End Function
	
	Function Create(of:Int, cf:Int, x:Float, y:Float, lvlpoint:Int = 0)
		Local t:TTile = New TTile
		ActiveTile = t
		AllTiles.Addlast(t)
		'If of = 16 Then of = 16 ; cf = 6
		t.objFrame = of
		t.colFrame = cf
		t.x = x
		t.y = y
		t.XZ = -1
		t.lvlp = lvlpoint
	End Function
	
	Function UpdateAll()
		For Local t:TTile = EachIn TTile.AllTiles
			t.Move()
			t.Draw()
			If t.objFrame < 0 And t.lifetime < ms Then t.Del()
		Next
	End Function
	
	Function Flush()
		TTile.ActiveTile = Null
		TTile.AllTiles.Clear()	
	End Function
	
End Type

Type TGameboard
	Field x:Int, y:Int, zeilen:Int, spalten:Int
	Field Feld:TTile[,]
	
	Method Draw()
		SetColor($88, $88, $88)
		Local xpos:Int = Self.x - (spalten * 32)
		Local ypos:Int = Self.y - (zeilen * 32)
		For Local y:Int = 0 Until zeilen
			For Local x:Int = 0 Until spalten
				DrawLine(xpos + x * 64, ypos, xpos + x * 64, ypos + zeilen * 64)
				DrawLine(xpos, ypos + y * 64, xpos + spalten * 64, ypos + y * 64)
			Next
		Next
		DrawLine(xpos + spalten * 64, ypos, xpos + spalten * 64, ypos + zeilen * 64)
		DrawLine(xpos, ypos + zeilen * 64, xpos + spalten * 64, ypos + zeilen * 64)
		SetColor($FF, $FF, $FF)
	End Method
	
	Method Mouse(intro:Int = False)
		If MouseInRect(x - spalten * 32, y - zeilen * 32, spalten * 64, zeilen * 64) Then
			Local xoff:Int = (gfx_w - spalten * 64) / 2
			Local yoff:Int = (gfx_h - zeilen * 64) / 2
			Local zx:Int = Limit((mx - xoff) / 64, 0, spalten - 1) * 64
			Local zy:Int = Limit((my - yoff) / 64, 0, zeilen - 1) * 64
				'SetColor(0, 0, 0)
				'DrawText(zx / 64 + "," + zy / 64, 10, 10)
				'SetColor($FF, $FF, $FF)
			If mh1 Then
				If Self.Feld[zx / 64, zy / 64] = Null Then
					If Self.Nachbarn(zx / 64, zy / 64) Or intro Then
						Self.Feld[zx / 64, zy / 64] = TTile.SetDestActiveTile(x - (spalten * 32) + zx + 32, y - (zeilen * 32) + zy + 32)
						Points:+10
						PlayMySound(SetzSnd)
					Else
						PlayMySound(MhMhSnd)
					EndIf
				EndIf
			EndIf
		EndIf
	End Method
	
	Method Nachbarn:Int(_x:Int, _y:Int)
		Rem
			TRUE wenn gesetzt werden darf
			Wenn eines der Nachbarfelder NICHT die 
			gleiche Farbe und/oder das 
			gleiche Symbol zeigt, darf auch nicht 
			gesetzt werden...

			* der Nachbar hat die gleiche Farbe (Rahmen, colFrame)
			* der Nachbar hat das gleiche Symbol (objFrame)
		Endrem
		Local R:Int = Place(Self, _x + 1, _y)
		Local L:Int = Place(Self, _x - 1, _y)
		Local U:Int = Place(Self, _x, _y + 1)
		Local O:Int = Place(Self, _x, _y - 1)

		If R = 0 Or L = 0 Or U = 0 Or O = 0 Then Return False
		If R = -1 And L = -1 And U = -1 And O = -1 Then Return False
		If R = 1 And L = 1 And U = 1 And O = 1 Then Return True
		Return True
		
		Function Place:Int(t:TGameboard, _x:Int, _y:Int)
			'* Gibt True zurück, wenn dieser Tile zum Aktiven passt.
			If InBereich(_x, 0, t.spalten - 1) And InBereich(_y, 0, t.zeilen - 1) Then
			    If t.Feld[_x, _y] = Null Then
					Return - 1
				Else
					If t.Feld[_x, _y].objFrame = 16 Or TTile.ActiveTile.ObjFrame = 16 Then
						Return True
					ElseIf Not((t.Feld[_x, _y].colFrame = TTile.ActiveTile.colFrame) Or (t.Feld[_x, _y].objFrame = TTile.ActiveTile.ObjFrame)) Then
						Return False
					EndIf
				EndIf
			Else
				Return - 1
			End If
			Return True
		End Function
		
	End Method
	
	Method Update()
		ColorStuff()
		Self.Draw()
		Self.Check()
		Self.Mouse()
	End Method
	
	Method Check()
		Local fill:Int = 0
		For Local y:Int = 0 Until Self.zeilen
			For Local x:Int = 0 Until Self.spalten
				If Self.Feld[x, y] <> Null Then fill:+1
			Next
			If fill = Self.spalten Then Self.Erease(y, 0) ; PlayMySound(EreaseSnd)
			fill = 0
		Next
		
		If Self.zeilen > 1 Then
			For Local x:Int = 0 Until Self.spalten
				For Local y:Int = 0 Until Self.zeilen
					If Self.Feld[x, y] <> Null Then fill:+1
				Next
				If fill = Self.zeilen Then Self.Erease(x, 1) ; PlayMySound(EreaseSnd)
				fill = 0
			Next
		EndIf
		
		For Local y:Int = 0 Until Self.zeilen
			For Local x:Int = 0 Until Self.spalten
				If Self.Feld[x, y] <> Null Then
					If Self.Feld[X, Y].objFrame < 0 Then Self.Feld[X, Y] = Null
				EndIf
			Next
		Next
	End Method
	
	Method Erease(zs:Int, hv:Int)
		If hv = 0 Then '* Horizontal y=const
			For Local i:Int = 0 Until Self.spalten
				Self.Feld[i, zs].Erease()
			Next
		Else '* Vertikal x=const
			For Local i:Int = 0 Until Self.zeilen
				Self.Feld[zs, i].Erease()
				Self.Feld[zs, i] = Null
			Next	
		End If
	End Method
	
	Method Flush()
		For Local y:Int = 0 Until Self.zeilen
			For Local x:Int = 0 Until Self.spalten
				If Self.Feld[x, y] <> Null Then Self.Feld[x, y] = Null
			Next
		Next
		TTile.Flush()
	End Method
	
	Method LoadLevel(LevelNr:Int)
		LevelTile = 0
		Local file:TStream = OpenFile("Data\Level\" + FormatLevelNumber(LevelNr) + ".txt")
			If file = Null Then Return 'RuntimeError("No Level " + LevelNr)
			For Local y:Int = 0 Until 8
				Local zeile:String = file.ReadLine()
				For Local x:Int = 0 Until zeile.Length
					If Int(Mid(zeile, x + 1, 1)) = 1 Then
						TTile.Create(Rand(0, 15), Rand(0, 5), gfx_w / 2, 64, 1)
						Self.Feld[x, y] = TTile.SetDestActiveTile(Self.x - (Self.spalten * 32) + x * 64 + 32, Self.y - (Self.zeilen * 32) + y * 64 + + 32)
						LevelTile:+1
					EndIf
				Next
			Next
		file.Close()	
	End Method
	
	Function Create:TGameboard(_x:Int, _y:Int, _zeilen:Int, _spalten:Int)
		Local B:TGameboard = New TGameboard
		B.x = _x
		B.y = _y
		B.zeilen = _zeilen
		B.spalten = _spalten
		B.Feld = New TTile[_spalten, _zeilen]
		Return B
	End Function
	
End Type

Type THighscore
	Field name:String, points:Int
	Global list:TList = CreateList()
	
	Method New()
		rem
			werden neue einträge vorne angehangen, werden bei gleichem Punktwert neue
			Einträge oben eingefügt - gibt dem Spieler ein größeres Erfolgserlebnis.
		endrem
		list.AddFirst(Self)
	End Method
	
	Method Compare:Int(H2:Object)
		rem
			Überladung der Compare-Methode erlaubt das Sortieren der Liste mit Sort()
			Sortierung erfolgt natürlich nach Punkten.
		endrem
		Return THighScore(H2).points - Self.points
	End Method
	
	Function Load()
		If FileType("Data\H.score") = 0 Then
			'* Neuer Highscore / erster Start
			For Local i:Int = 1 To 5
				THighscore.Add("DDDDD", i * 10500)
			Next
			THighscore.list.Sort()
		Else
			'* Alten Highscore lesen.
			Local f:TStream = OpenFile("Data\H.score")
			For Local i:Int = 0 Until 5
				Local l:Int = f.ReadInt()
				Local n:String = f.ReadString(l)
				Local p:Int = f.ReadInt()
				THighScore.Add(n, p)
			Next
			CloseFile(f)
			THighscore.list.Sort()
		EndIf
	End Function
	
	Function Save()
		THighScore.list.Sort()
		Local f:TStream = WriteFile("Data\H.score")
		'* Nur die ersten 10 Plätze werden gespeichert.
		For Local i:Int = 0 Until 5
			Local H:THighScore = THighScore(THighScore.list.ValueAtIndex(i))
			f.WriteInt(H.name.Length)
			f.WriteString(H.name)
			f.WriteInt(H.points)
		Next
		CloseFile(f)
	End Function
	
	Function Add(_name:String, _points:Int)
		Local H:THighScore = New THighScore
		H.name = _name
		H.points = _points
	End Function
	
	Function DrawHigh(s:String, _x:Int, _y:Int)
		Local i:Int
		For Local b:Int = 0 Until s.Length
			DrawImage(TileSet, _x + 64 * i - (s.Length - 1) * 32, _y, s[b] - 65)
			i:+1
		Next
	End Function
End Type

Function SaveOptions()
	Local f:TStream = WriteFile("Data\OPT")
	f.WriteByte(Volume)
	f.Close()
End Function

Function LoadOptions()
	If FileType("Data\OPT") = 1 Then
		Local f:TStream = ReadFile("Data\OPT")
		Volume = f.ReadByte()
		f.Close()
	End If
End Function

Function ButtonImg:Int(img:TImage, _x:Int, _y:Int, frame:Int, frame2:Int = 0, _sound:TSound = Null)
	If frame2 < 0 Then frame2 = frame
	If MouseInRect(_x - img.width / 2, _y - img.height / 2, img.width, img.height) Then
		DrawImage(img, _x, _y, frame2)
		mousehover = True
		If mousehoverOld = False Then PlayMySound(ButtonPitSnd)
		If mh1 = True Then
			If _sound <> Null Then PlayMySound(_sound)
			Return True
		EndIf
	Else
		DrawImage(img, _x, _y, frame)
	EndIf
End Function

Function FormatLevelNumber:String(_nr:Int)
	Local re:String = String(_nr)
	If re.Length = 1 Then
		re = "00" + re
	ElseIf re.Length = 2 Then
		re = "0" + re
	EndIf
	Return re
End Function

Function ColorStuff()
	Select CC
	Case 0
		CG:-4 ; CB:+4
		If CG <= 0 Then CC = 1
	Case 1
		CB:-4 ; CR:+4
		If CB <= 0 Then CC = 2
	Case 2
		CR:-4 ; CG:+4
		If CR <= 0 Then CC = 0
	End Select
End Function

Function MouseInRect:Int(x:Int, y:Int, w:Int, h:Int)
	If mx <= x Then Return False
	If my <= y Then Return False
	If mx >= x + w Then Return False
	If my >= y + h Then Return False
	Return True	
End Function

Function PlayMySound(_sound:TSound)
	If Volume = 3 Then Return
	Local c:TChannel = PlaySound(_sound)
	c.SetVolume(1.0 - (Volume / 3.0))
End Function

Function DrawTextMid(txt:String, X:Float, Y:Float)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	DrawText(txt, Int(X - (Float(TextWidth(txt)) * scale_X / 2.0)), Int(Y - (Float(TextHeight(txt)) * scale_Y / 2.0)))
End Function

Function Limit:Int(_value:Int, _Min:Int, _Max:Int)
	If _value < _Min Then
		Return _Min
	ElseIf _value > _Max Then
		Return _max
	Else
		Return _value
	EndIf
End Function

Function InBereich:Int(_value:Int, _Min:Int, _Max:Int)
	If _value < _Min Then Return False
	If _value > _Max Then Return False
	Return True
End Function

Function SecsToTime:String(_value:Int)
	Local m:String = String(_value / 60)
	Local S:String = String(_value Mod 60)
	If Len(m) = 1 Then m = "0" + m
	If Len(s) = 1 Then s = "0" + s
	Return m + ":" + s
End Function
