Graphics 640,480,8,2
SetBuffer BackBuffer()
timer = CreateTimer(60)
SeedRnd MilliSecs()
TFormFilter 0

Global tileset = LoadAnimImage(".\gfx\tileset.png",32,32,0,4)
MaskImage tileset,255,0,255
Global ts = LoadImage(".\gfx\startscreen.png")
Global gos = LoadImage(".\gfx\gameover.png")
Global ws = LoadImage(".\gfx\win.png")
Global bgm = LoadSound(".\259908_Sad_Loop.mp3")
LoopSound bgm
Global chn
Global chn_on = True
;FG und BG
Dim fg(23)
Dim bg(23)
For i = 0 To 23
	If i < 10 Then
		fg(i) = LoadImage(".\gfx\fg0"+i+".png")
		MaskImage fg(i),255,0,255
		bg(i) = LoadImage(".\gfx\bg0"+i+".png")
	Else
		fg(i) = LoadImage(".\gfx\fg"+i+".png")
		MaskImage fg(i),255,0,255
		bg(i) = LoadImage(".\gfx\bg"+i+".png")
	EndIf
Next


;Objekte
Dim rotor_pic(2)
rotor_pic(1) = LoadAnimImage(".\gfx\rotor_small.png",115,116,0,4)
MaskImage rotor_pic(1),255,0,255
MidHandle rotor_pic(1)
rotor_pic(2) = LoadAnimImage(".\gfx\rotor_big.png",155,155,0,4)
MaskImage rotor_pic(2),255,0,255
MidHandle rotor_pic(2)
Global live = LoadImage(".\gfx\live.png")
MaskImage live,255,0,255
Global jumps = LoadAnimImage(".\gfx\jumper.png",32,32,0,4)
MaskImage jumps,255,0,255
Global items = LoadAnimImage(".\gfx\item.png",32,32,0,2)
MaskImage items,255,0,255
;Spielerimage
Dim blobb(1)
blobb(1) = LoadAnimImage(".\gfx\typ.png",32,32,0,4)
MaskImage blobb(1),255,0,255
blobb(0) = LoadAnimImage(".\gfx\typ.png",32,32,0,4)
MaskImage blobb(0),255,0,255
ScaleImage blobb(0),-1,1
HandleImage blobb(0),0,0

Global currmap = 0
Global dead = 0
Global gameover = False
Global win = False
Global lives = 3
Dim xtracollected(3)
Global jump = 0
Global respawn_x,respawn_y
Global gotkey = False

Type rotor
	Field x,y
	Field frame
	Field size
	Field speed
End Type

Type jumper
	Field x,y
	Field frame
End Type

Type emitter
	Field x,y
	Field r,g,b
	Field time,wait
	Field amin,amax
	Field pmin,pmax
End Type

Type key
	Field x,y
End Type

Type extralive
	Field x,y
End Type

Type particle
	Field x#,y#
	Field angle#
	Field r,g,b
	Field time,dur
End Type

Type typ
	Field x,y#,dwspeed#
	Field frame,dir
End Type

Dim map(20,15,24)
Global maps = ReadFile(".\maps.dat")
For mp = 0 To 23
	leer$ = ReadLine(maps)
	For y = 0 To 14
		line_y$ = ReadLine(maps)
		For x = 0 To 19
			map(x,y,mp) = Mid(line_y$,1+x*2,1)
		Next
	Next
Next

chn = PlaySound(bgm)
.menue
reset()
FlushKeys()
ClsColor(128,128,128)
Repeat
	Cls
	soundcontrol()
	If KeyHit(57) Then Goto game
	DrawImage ts,0,0
	WaitTimer(timer)
	Flip
Until KeyHit(28)
End
.game
t.typ = New typ
t\x = 96
t\y = 384
Repeat
	Cls
	If gameover = False
	soundcontrol()
	cntrl()
	dying()
	rotors()
	emitters()
	particles()
	EndIf
	draw()
	WaitTimer(timer)
	Flip
Until KeyHit(1) Or gameover = True
FlushKeys()
Cls
DrawImage gos,270,190
Flip
WaitKey()
Goto menue

Function cntrl()
	For t.typ = Each typ
		If KeyDown(203) Then
			t\x = t\x - 3
			If t\x < -31 Then
				currmap = currmap - 1
				t\x = 608
				mapchange()
			EndIf
			t\dir = 0
			t\frame = t\frame + 1
			If t\frame > 19 Then t\frame = 0
			If t\x > -1 Then
				For i = 1 To 3
					If map(t\x/32,t\y/32,currmap) Then
						t\x = t\x + 1
					EndIf
				Next
			EndIf
		ElseIf KeyDown(205) Then
			t\x = t\x + 3
			If t\x > 639 Then
				currmap = currmap + 1
				t\x = 0
				mapchange()
			EndIf
			t\dir = 1
			t\frame = t\frame + 1
			If t\frame > 19 Then t\frame = 0
			If t\x <= 608 And t\y > -1 Then
				For i = 1 To 3
					If map(t\x/32+1,t\y/32,currmap) Then
						t\x = t\x - 1
					EndIf
				Next
			EndIf
		Else
			t\frame = 0
		EndIf
		If KeyHit(57) And t\dwspeed = 0 Then
			t\dwspeed = -6-(2*jump)
		EndIf
		If t\x <= 632 And t\x > -25 Then
			t\dwspeed = t\dwspeed + 0.4
			t\y = t\y + t\dwspeed
			For y=0 To 14
				For x=0 To 19
					If ImagesCollide(tileset,x*32,y*32,map(x,y,currmap),blobb(t\dir),t\x,t\y,t\frame/5) Then
						If (t\y < y*32-26+t\dwspeed) Or t\y > y*32+31+t\dwspeed Then
							t\y = t\y - t\dwspeed
							t\dwspeed = 0
						EndIf
					EndIf
				Next
			Next
			If t\y > 480 Then
				t\y = 0
				currmap = currmap + 6
				mapchange()
			ElseIf t\y < -25 Then
				t\y = 448
				currmap = currmap - 6
				mapchange()
			EndIf
		EndIf
	Next
End Function

Function dying()
	For t.typ = Each typ
		For y=0 To 14
			For x=0 To 19
				If map(x,y,currmap) = 2 Then
					If ImagesCollide(tileset,x*32,y*32,2,blobb(t\dir),t\x,t\y,t\frame/5) Then
						dead = True
					EndIf
				EndIf
			Next
		Next
		For r.rotor = Each rotor
			If ImagesCollide(rotor_pic(r\size),r\x,r\y,r\frame/r\speed,blobb(t\dir),t\x,t\y,t\frame/5) Then
				dead = True
			EndIf
		Next
		For j.jumper = Each jumper
			If ImagesCollide(jumps,j\x,j\y,j\frame/5,blobb(t\dir),t\x,t\y,t\frame/5) Then
				For i = 1 To 25
					p.particle = New particle
					p\x = j\x+16
					p\y = j\y+16
					p\angle = Rnd(1,359)
					p\r = 230
					p\g = 230
					p\b = 0
					p\dur = Rand(50,100)
				Next
				Delete j.jumper
				jump = jump + 1
			EndIf
		Next
		For ex.extralive = Each extralive
			If ImagesCollide(items,ex\x,ex\y,0,blobb(t\dir),t\x,t\y,t\frame/5) Then
				For i = 1 To 10
					p.particle = New particle
					p\x = ex\x+16
					p\y = ex\y+16
					p\angle = Rnd(1,359)
					p\r = 0
					p\g = 148
					p\b = 255
					p\dur = Rand(50,100)
				Next
				Delete ex.extralive
				lives = lives + 1
				Select currmap
				Case 7
					xtracollected(1) = 1
				Case 10
					xtracollected(0) = 1
				Case 12
					xtracollected(2) = 1
				End Select
			EndIf
		Next
		For k.key = Each key
			If ImagesCollide(items,k\x,k\y,1,blobb(t\dir),t\x,t\y,t\frame/5) Then
				Delete k.key
				gotkey = True
				map(10,5,3) = 0
			EndIf
		Next
	Next
	If dead = True Then
		dead = False
		For t.typ = Each typ
			t\x = respawn_x
			t\y = respawn_y
			t\dwspeed = 0
		Next
		lives = lives - 1
		If lives = -1 Then gameover = True
	EndIf
End Function

Function emitters()
	For e.emitter = Each emitter
		e\time = e\time+1
		If e\time = e\wait Then
			For i = 1 To Rand(e\pmin,e\pmax)
				p.particle = New particle
				p\x = e\x
				p\y = e\y
				p\angle = Rnd(e\amin,e\amax)
				p\r = e\r
				p\g = e\g
				p\b = e\b
				p\dur = Rand(50,100)
			Next
			e\time = 0
		EndIf
	Next
End Function

Function particles()
	For p.particle = Each particle
		p\x = p\x + Sin(p\angle)*2
		p\y = p\y - Cos(p\angle)*2
		If p\angle < 180 Then
			p\angle = p\angle + 4
		ElseIf p\angle > 180 Then
			p\angle = p\angle - 4
		EndIf
		p\time = p\time + 1
		If p\time > p\dur Then
			Delete p.particle
		EndIf
	Next
End Function

Function rotors()
	For r.rotor = Each rotor
		r\frame = r\frame + 1
		If r\frame = 4*r\speed Then r\frame = 0
	Next
End Function

Function mapchange()
	If currmap = -3 Then
		FlushKeys()
		Cls
		DrawImage ws,0,0
		Flip
		WaitKey()
		End
	EndIf
	For e.emitter = Each emitter
		Delete e.emitter
	Next
	For r.rotor = Each rotor
		Delete r.rotor
	Next
	For p.particle = Each particle
		Delete p.particle
	Next
	For ex.extralive = Each extralive
		Delete ex.extralive
	Next
	For k.key = Each key
		Delete k.key
	Next
	For j.jumper = Each jumper
		Delete j.jumper
	Next
	Select currmap
	Case 4
		If gotkey = False
			k.key = New key
			k\x = 416
			k\y = 352
		EndIf
	Case 7
		r.rotor = New rotor
		r\x = 384
		r\y = 352
		r\size = 1
		r\speed = 20
		If xtracollected(1) = 0 Then
			ex.extralive = New extralive
			ex\x = 544
			ex\y = 354
		EndIf
	Case 10
		If xtracollected(0) = 0 Then
			ex.extralive = New extralive
			ex\x = 480
			ex\y = 416
		EndIf
	Case 11
		r.rotor = New rotor
		r\x = 192
		r\y = 288
		r\size = 2
		r\speed = 10
		r.rotor = New rotor
		r\x = 416
		r\y = 288
		r\size = 2
		r\speed = 20
	Case 12
		r.rotor = New rotor
		r\x = 288
		r\y = 352
		r\size = 2
		r\speed = 10
		If xtracollected(2) = 0 Then
			ex.extralive = New extralive
			ex\x = 224
			ex\y = 96
		EndIf
	Case 13
		If jump = 0 Then
			j.jumper = New jumper
			j\x = 64
			j\y = 320
		EndIf
	Case 14
		e.emitter = New emitter
		e\x = 416
		e\y = 271
		e\r = 100
		e\g = 211
		e\b = 255
		e\wait = 90
		e\amin = 135
		e\amax = 225
		e\pmin = 2
		e\pmax = 4
		e.emitter = New emitter
		e\x = 180
		e\y = 63
		e\r = 0
		e\g = 0
		e\b = 0
		e\wait = 30
		e\amin = 179
		e\amax = 185
		e\pmin = 1
		e\pmax = 2
	Case 15
		e.emitter = New emitter
		e\x = 525
		e\y = 230
		e\r = 100
		e\g = 211
		e\b = 255
		e\wait = 60
		e\amin = 45
		e\amax = 315
		e\pmin = 3
		e\pmax = 7
		r.rotor = New rotor
		r\x = 320
		r\y = 230
		r\size = 2
		r\speed = 10
	Case 18
		r.rotor = New rotor
		r\x = 160
		r\y = 256
		r\size = 1
		r\speed = 4
		r.rotor = New rotor
		r\x = 352
		r\y = 256
		r\size = 1
		r\speed = 4
	Case 22
		r.rotor = New rotor
		r\x = 384
		r\y = 96
		r\size = 1
		r\speed = 4
		r.rotor = New rotor
		r\x = 96
		r\y = 384
		r\size = 1
		r\speed = 4
		r.rotor = New rotor
		r\x = 544
		r\y = 384
		r\size = 1
		r\speed = 4
	End Select
	For t.typ = Each typ
		respawn_x = t\x
		respawn_y = t\y
	Next
End Function

Function draw()
	DrawImage bg(currmap),0,0
	For y = 0 To 14
		For x = 0 To 19
			DrawImage tileset,x*32,y*32,map(x,y,currmap)
		Next
	Next
	For j.jumper = Each jumper
		j\frame = j\frame + 1
		If j\frame > 19 Then j\frame = 0
		DrawImage jumps,j\x,j\y,j\frame/5
	Next
	For t.typ = Each typ
		DrawImage blobb(t\dir),t\x,t\y,t\frame/5
	Next
	For ex.extralive = Each extralive
		DrawImage items,ex\x,ex\y,0
	Next
	For k.key = Each key
		DrawImage items,k\x,k\y,1
	Next
	For r.rotor = Each rotor
		DrawImage rotor_pic(r\size),r\x,r\y,r\frame/r\speed
	Next
	DrawImage fg(currmap),0,0
	For p.particle = Each particle
		Color p\r,p\g,p\b
		Plot p\x,p\y
	Next
	Color 255,255,255
	If lives > 0 Then
		For i = 0 To (lives-1)
			DrawImage live,i*16,0
		Next
	EndIf
End Function

Function reset()
	For t.typ = Each typ
		Delete t.typ
	Next
	For e.emitter = Each emitter
		Delete e.emitter
	Next
	For r.rotor = Each rotor
		Delete r.rotor
	Next
	For p.particle = Each particle
		Delete p.particle
	Next
	For ex.extralive = Each extralive
		Delete ex.extralive
	Next
	For k.key = Each key
		Delete k.key
	Next
	For j.jumper = Each jumper
		Delete j.jumper
	Next
	currmap = 0
	dead = 0
	gameover = False
	win = False
	lives = 3
	For i = 0 To 2
		xtracollected(i) = 0
	Next
	jump = 0
	respawn_x=0
	respawn_y=0
	gotkey = False
End Function

Function soundcontrol()
	If KeyHit(59) Then
		If chn_on = False Then
			ChannelVolume chn,1
			chn_on = True
		Else
			ChannelVolume chn,0
			chn_on = False
		EndIf
	EndIf
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D